package com.ruoyi.system.domain.zb;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;

public class ZbReportRelationshipExample implements Serializable {
    protected String orderByClause;

    protected boolean distinct;

    protected List<Criteria> oredCriteria;

    private static final long serialVersionUID = 1L;

    public ZbReportRelationshipExample() {
        oredCriteria = new ArrayList<Criteria>();
    }

    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    public String getOrderByClause() {
        return orderByClause;
    }

    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    protected abstract static class GeneratedCriteria implements Serializable {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<Criterion>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        public Criteria andIdIsNull() {
            addCriterion("id is null");
            return (Criteria) this;
        }

        public Criteria andIdIsNotNull() {
            addCriterion("id is not null");
            return (Criteria) this;
        }

        public Criteria andIdEqualTo(String value) {
            addCriterion("id =", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotEqualTo(String value) {
            addCriterion("id <>", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThan(String value) {
            addCriterion("id >", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThanOrEqualTo(String value) {
            addCriterion("id >=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThan(String value) {
            addCriterion("id <", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThanOrEqualTo(String value) {
            addCriterion("id <=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLike(String value) {
            addCriterion("id like", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotLike(String value) {
            addCriterion("id not like", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdIn(List<String> values) {
            addCriterion("id in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotIn(List<String> values) {
            addCriterion("id not in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdBetween(String value1, String value2) {
            addCriterion("id between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotBetween(String value1, String value2) {
            addCriterion("id not between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andUserIdIsNull() {
            addCriterion("user_id is null");
            return (Criteria) this;
        }

        public Criteria andUserIdIsNotNull() {
            addCriterion("user_id is not null");
            return (Criteria) this;
        }

        public Criteria andUserIdEqualTo(String value) {
            addCriterion("user_id =", value, "userId");
            return (Criteria) this;
        }

        public Criteria andUserIdNotEqualTo(String value) {
            addCriterion("user_id <>", value, "userId");
            return (Criteria) this;
        }

        public Criteria andUserIdGreaterThan(String value) {
            addCriterion("user_id >", value, "userId");
            return (Criteria) this;
        }

        public Criteria andUserIdGreaterThanOrEqualTo(String value) {
            addCriterion("user_id >=", value, "userId");
            return (Criteria) this;
        }

        public Criteria andUserIdLessThan(String value) {
            addCriterion("user_id <", value, "userId");
            return (Criteria) this;
        }

        public Criteria andUserIdLessThanOrEqualTo(String value) {
            addCriterion("user_id <=", value, "userId");
            return (Criteria) this;
        }

        public Criteria andUserIdLike(String value) {
            addCriterion("user_id like", value, "userId");
            return (Criteria) this;
        }

        public Criteria andUserIdNotLike(String value) {
            addCriterion("user_id not like", value, "userId");
            return (Criteria) this;
        }

        public Criteria andUserIdIn(List<String> values) {
            addCriterion("user_id in", values, "userId");
            return (Criteria) this;
        }

        public Criteria andUserIdNotIn(List<String> values) {
            addCriterion("user_id not in", values, "userId");
            return (Criteria) this;
        }

        public Criteria andUserIdBetween(String value1, String value2) {
            addCriterion("user_id between", value1, value2, "userId");
            return (Criteria) this;
        }

        public Criteria andUserIdNotBetween(String value1, String value2) {
            addCriterion("user_id not between", value1, value2, "userId");
            return (Criteria) this;
        }

        public Criteria andUserNameIsNull() {
            addCriterion("user_name is null");
            return (Criteria) this;
        }

        public Criteria andUserNameIsNotNull() {
            addCriterion("user_name is not null");
            return (Criteria) this;
        }

        public Criteria andUserNameEqualTo(String value) {
            addCriterion("user_name =", value, "userName");
            return (Criteria) this;
        }

        public Criteria andUserNameNotEqualTo(String value) {
            addCriterion("user_name <>", value, "userName");
            return (Criteria) this;
        }

        public Criteria andUserNameGreaterThan(String value) {
            addCriterion("user_name >", value, "userName");
            return (Criteria) this;
        }

        public Criteria andUserNameGreaterThanOrEqualTo(String value) {
            addCriterion("user_name >=", value, "userName");
            return (Criteria) this;
        }

        public Criteria andUserNameLessThan(String value) {
            addCriterion("user_name <", value, "userName");
            return (Criteria) this;
        }

        public Criteria andUserNameLessThanOrEqualTo(String value) {
            addCriterion("user_name <=", value, "userName");
            return (Criteria) this;
        }

        public Criteria andUserNameLike(String value) {
            addCriterion("user_name like", value, "userName");
            return (Criteria) this;
        }

        public Criteria andUserNameNotLike(String value) {
            addCriterion("user_name not like", value, "userName");
            return (Criteria) this;
        }

        public Criteria andUserNameIn(List<String> values) {
            addCriterion("user_name in", values, "userName");
            return (Criteria) this;
        }

        public Criteria andUserNameNotIn(List<String> values) {
            addCriterion("user_name not in", values, "userName");
            return (Criteria) this;
        }

        public Criteria andUserNameBetween(String value1, String value2) {
            addCriterion("user_name between", value1, value2, "userName");
            return (Criteria) this;
        }

        public Criteria andUserNameNotBetween(String value1, String value2) {
            addCriterion("user_name not between", value1, value2, "userName");
            return (Criteria) this;
        }

        public Criteria andDepIdIsNull() {
            addCriterion("dep_id is null");
            return (Criteria) this;
        }

        public Criteria andDepIdIsNotNull() {
            addCriterion("dep_id is not null");
            return (Criteria) this;
        }

        public Criteria andDepIdEqualTo(String value) {
            addCriterion("dep_id =", value, "depId");
            return (Criteria) this;
        }

        public Criteria andDepIdNotEqualTo(String value) {
            addCriterion("dep_id <>", value, "depId");
            return (Criteria) this;
        }

        public Criteria andDepIdGreaterThan(String value) {
            addCriterion("dep_id >", value, "depId");
            return (Criteria) this;
        }

        public Criteria andDepIdGreaterThanOrEqualTo(String value) {
            addCriterion("dep_id >=", value, "depId");
            return (Criteria) this;
        }

        public Criteria andDepIdLessThan(String value) {
            addCriterion("dep_id <", value, "depId");
            return (Criteria) this;
        }

        public Criteria andDepIdLessThanOrEqualTo(String value) {
            addCriterion("dep_id <=", value, "depId");
            return (Criteria) this;
        }

        public Criteria andDepIdLike(String value) {
            addCriterion("dep_id like", value, "depId");
            return (Criteria) this;
        }

        public Criteria andDepIdNotLike(String value) {
            addCriterion("dep_id not like", value, "depId");
            return (Criteria) this;
        }

        public Criteria andDepIdIn(List<String> values) {
            addCriterion("dep_id in", values, "depId");
            return (Criteria) this;
        }

        public Criteria andDepIdNotIn(List<String> values) {
            addCriterion("dep_id not in", values, "depId");
            return (Criteria) this;
        }

        public Criteria andDepIdBetween(String value1, String value2) {
            addCriterion("dep_id between", value1, value2, "depId");
            return (Criteria) this;
        }

        public Criteria andDepIdNotBetween(String value1, String value2) {
            addCriterion("dep_id not between", value1, value2, "depId");
            return (Criteria) this;
        }

        public Criteria andDepNameIsNull() {
            addCriterion("dep_name is null");
            return (Criteria) this;
        }

        public Criteria andDepNameIsNotNull() {
            addCriterion("dep_name is not null");
            return (Criteria) this;
        }

        public Criteria andDepNameEqualTo(String value) {
            addCriterion("dep_name =", value, "depName");
            return (Criteria) this;
        }

        public Criteria andDepNameNotEqualTo(String value) {
            addCriterion("dep_name <>", value, "depName");
            return (Criteria) this;
        }

        public Criteria andDepNameGreaterThan(String value) {
            addCriterion("dep_name >", value, "depName");
            return (Criteria) this;
        }

        public Criteria andDepNameGreaterThanOrEqualTo(String value) {
            addCriterion("dep_name >=", value, "depName");
            return (Criteria) this;
        }

        public Criteria andDepNameLessThan(String value) {
            addCriterion("dep_name <", value, "depName");
            return (Criteria) this;
        }

        public Criteria andDepNameLessThanOrEqualTo(String value) {
            addCriterion("dep_name <=", value, "depName");
            return (Criteria) this;
        }

        public Criteria andDepNameLike(String value) {
            addCriterion("dep_name like", value, "depName");
            return (Criteria) this;
        }

        public Criteria andDepNameNotLike(String value) {
            addCriterion("dep_name not like", value, "depName");
            return (Criteria) this;
        }

        public Criteria andDepNameIn(List<String> values) {
            addCriterion("dep_name in", values, "depName");
            return (Criteria) this;
        }

        public Criteria andDepNameNotIn(List<String> values) {
            addCriterion("dep_name not in", values, "depName");
            return (Criteria) this;
        }

        public Criteria andDepNameBetween(String value1, String value2) {
            addCriterion("dep_name between", value1, value2, "depName");
            return (Criteria) this;
        }

        public Criteria andDepNameNotBetween(String value1, String value2) {
            addCriterion("dep_name not between", value1, value2, "depName");
            return (Criteria) this;
        }

        public Criteria andReportIdIsNull() {
            addCriterion("report_id is null");
            return (Criteria) this;
        }

        public Criteria andReportIdIsNotNull() {
            addCriterion("report_id is not null");
            return (Criteria) this;
        }

        public Criteria andReportIdEqualTo(String value) {
            addCriterion("report_id =", value, "reportId");
            return (Criteria) this;
        }

        public Criteria andReportIdNotEqualTo(String value) {
            addCriterion("report_id <>", value, "reportId");
            return (Criteria) this;
        }

        public Criteria andReportIdGreaterThan(String value) {
            addCriterion("report_id >", value, "reportId");
            return (Criteria) this;
        }

        public Criteria andReportIdGreaterThanOrEqualTo(String value) {
            addCriterion("report_id >=", value, "reportId");
            return (Criteria) this;
        }

        public Criteria andReportIdLessThan(String value) {
            addCriterion("report_id <", value, "reportId");
            return (Criteria) this;
        }

        public Criteria andReportIdLessThanOrEqualTo(String value) {
            addCriterion("report_id <=", value, "reportId");
            return (Criteria) this;
        }

        public Criteria andReportIdLike(String value) {
            addCriterion("report_id like", value, "reportId");
            return (Criteria) this;
        }

        public Criteria andReportIdNotLike(String value) {
            addCriterion("report_id not like", value, "reportId");
            return (Criteria) this;
        }

        public Criteria andReportIdIn(List<String> values) {
            addCriterion("report_id in", values, "reportId");
            return (Criteria) this;
        }

        public Criteria andReportIdNotIn(List<String> values) {
            addCriterion("report_id not in", values, "reportId");
            return (Criteria) this;
        }

        public Criteria andReportIdBetween(String value1, String value2) {
            addCriterion("report_id between", value1, value2, "reportId");
            return (Criteria) this;
        }

        public Criteria andReportIdNotBetween(String value1, String value2) {
            addCriterion("report_id not between", value1, value2, "reportId");
            return (Criteria) this;
        }

        public Criteria andBsCommonIdIsNull() {
            addCriterion("bs_common_id is null");
            return (Criteria) this;
        }

        public Criteria andBsCommonIdIsNotNull() {
            addCriterion("bs_common_id is not null");
            return (Criteria) this;
        }

        public Criteria andBsCommonIdEqualTo(String value) {
            addCriterion("bs_common_id =", value, "bsCommonId");
            return (Criteria) this;
        }

        public Criteria andBsCommonIdNotEqualTo(String value) {
            addCriterion("bs_common_id <>", value, "bsCommonId");
            return (Criteria) this;
        }

        public Criteria andBsCommonIdGreaterThan(String value) {
            addCriterion("bs_common_id >", value, "bsCommonId");
            return (Criteria) this;
        }

        public Criteria andBsCommonIdGreaterThanOrEqualTo(String value) {
            addCriterion("bs_common_id >=", value, "bsCommonId");
            return (Criteria) this;
        }

        public Criteria andBsCommonIdLessThan(String value) {
            addCriterion("bs_common_id <", value, "bsCommonId");
            return (Criteria) this;
        }

        public Criteria andBsCommonIdLessThanOrEqualTo(String value) {
            addCriterion("bs_common_id <=", value, "bsCommonId");
            return (Criteria) this;
        }

        public Criteria andBsCommonIdLike(String value) {
            addCriterion("bs_common_id like", value, "bsCommonId");
            return (Criteria) this;
        }

        public Criteria andBsCommonIdNotLike(String value) {
            addCriterion("bs_common_id not like", value, "bsCommonId");
            return (Criteria) this;
        }

        public Criteria andBsCommonIdIn(List<String> values) {
            addCriterion("bs_common_id in", values, "bsCommonId");
            return (Criteria) this;
        }

        public Criteria andBsCommonIdNotIn(List<String> values) {
            addCriterion("bs_common_id not in", values, "bsCommonId");
            return (Criteria) this;
        }

        public Criteria andBsCommonIdBetween(String value1, String value2) {
            addCriterion("bs_common_id between", value1, value2, "bsCommonId");
            return (Criteria) this;
        }

        public Criteria andBsCommonIdNotBetween(String value1, String value2) {
            addCriterion("bs_common_id not between", value1, value2, "bsCommonId");
            return (Criteria) this;
        }

        public Criteria andBsCommonParentIdIsNull() {
            addCriterion("bs_common_parent_id is null");
            return (Criteria) this;
        }

        public Criteria andBsCommonParentIdIsNotNull() {
            addCriterion("bs_common_parent_id is not null");
            return (Criteria) this;
        }

        public Criteria andBsCommonParentIdEqualTo(String value) {
            addCriterion("bs_common_parent_id =", value, "bsCommonParentId");
            return (Criteria) this;
        }

        public Criteria andBsCommonParentIdNotEqualTo(String value) {
            addCriterion("bs_common_parent_id <>", value, "bsCommonParentId");
            return (Criteria) this;
        }

        public Criteria andBsCommonParentIdGreaterThan(String value) {
            addCriterion("bs_common_parent_id >", value, "bsCommonParentId");
            return (Criteria) this;
        }

        public Criteria andBsCommonParentIdGreaterThanOrEqualTo(String value) {
            addCriterion("bs_common_parent_id >=", value, "bsCommonParentId");
            return (Criteria) this;
        }

        public Criteria andBsCommonParentIdLessThan(String value) {
            addCriterion("bs_common_parent_id <", value, "bsCommonParentId");
            return (Criteria) this;
        }

        public Criteria andBsCommonParentIdLessThanOrEqualTo(String value) {
            addCriterion("bs_common_parent_id <=", value, "bsCommonParentId");
            return (Criteria) this;
        }

        public Criteria andBsCommonParentIdLike(String value) {
            addCriterion("bs_common_parent_id like", value, "bsCommonParentId");
            return (Criteria) this;
        }

        public Criteria andBsCommonParentIdNotLike(String value) {
            addCriterion("bs_common_parent_id not like", value, "bsCommonParentId");
            return (Criteria) this;
        }

        public Criteria andBsCommonParentIdIn(List<String> values) {
            addCriterion("bs_common_parent_id in", values, "bsCommonParentId");
            return (Criteria) this;
        }

        public Criteria andBsCommonParentIdNotIn(List<String> values) {
            addCriterion("bs_common_parent_id not in", values, "bsCommonParentId");
            return (Criteria) this;
        }

        public Criteria andBsCommonParentIdBetween(String value1, String value2) {
            addCriterion("bs_common_parent_id between", value1, value2, "bsCommonParentId");
            return (Criteria) this;
        }

        public Criteria andBsCommonParentIdNotBetween(String value1, String value2) {
            addCriterion("bs_common_parent_id not between", value1, value2, "bsCommonParentId");
            return (Criteria) this;
        }

        public Criteria andLeaderFlagIsNull() {
            addCriterion("leader_flag is null");
            return (Criteria) this;
        }

        public Criteria andLeaderFlagIsNotNull() {
            addCriterion("leader_flag is not null");
            return (Criteria) this;
        }

        public Criteria andLeaderFlagEqualTo(Byte value) {
            addCriterion("leader_flag =", value, "leaderFlag");
            return (Criteria) this;
        }

        public Criteria andLeaderFlagNotEqualTo(Byte value) {
            addCriterion("leader_flag <>", value, "leaderFlag");
            return (Criteria) this;
        }

        public Criteria andLeaderFlagGreaterThan(Byte value) {
            addCriterion("leader_flag >", value, "leaderFlag");
            return (Criteria) this;
        }

        public Criteria andLeaderFlagGreaterThanOrEqualTo(Byte value) {
            addCriterion("leader_flag >=", value, "leaderFlag");
            return (Criteria) this;
        }

        public Criteria andLeaderFlagLessThan(Byte value) {
            addCriterion("leader_flag <", value, "leaderFlag");
            return (Criteria) this;
        }

        public Criteria andLeaderFlagLessThanOrEqualTo(Byte value) {
            addCriterion("leader_flag <=", value, "leaderFlag");
            return (Criteria) this;
        }

        public Criteria andLeaderFlagIn(List<Byte> values) {
            addCriterion("leader_flag in", values, "leaderFlag");
            return (Criteria) this;
        }

        public Criteria andLeaderFlagNotIn(List<Byte> values) {
            addCriterion("leader_flag not in", values, "leaderFlag");
            return (Criteria) this;
        }

        public Criteria andLeaderFlagBetween(Byte value1, Byte value2) {
            addCriterion("leader_flag between", value1, value2, "leaderFlag");
            return (Criteria) this;
        }

        public Criteria andLeaderFlagNotBetween(Byte value1, Byte value2) {
            addCriterion("leader_flag not between", value1, value2, "leaderFlag");
            return (Criteria) this;
        }

        public Criteria andFillFlagIsNull() {
            addCriterion("fill_flag is null");
            return (Criteria) this;
        }

        public Criteria andFillFlagIsNotNull() {
            addCriterion("fill_flag is not null");
            return (Criteria) this;
        }

        public Criteria andFillFlagEqualTo(Byte value) {
            addCriterion("fill_flag =", value, "fillFlag");
            return (Criteria) this;
        }

        public Criteria andFillFlagNotEqualTo(Byte value) {
            addCriterion("fill_flag <>", value, "fillFlag");
            return (Criteria) this;
        }

        public Criteria andFillFlagGreaterThan(Byte value) {
            addCriterion("fill_flag >", value, "fillFlag");
            return (Criteria) this;
        }

        public Criteria andFillFlagGreaterThanOrEqualTo(Byte value) {
            addCriterion("fill_flag >=", value, "fillFlag");
            return (Criteria) this;
        }

        public Criteria andFillFlagLessThan(Byte value) {
            addCriterion("fill_flag <", value, "fillFlag");
            return (Criteria) this;
        }

        public Criteria andFillFlagLessThanOrEqualTo(Byte value) {
            addCriterion("fill_flag <=", value, "fillFlag");
            return (Criteria) this;
        }

        public Criteria andFillFlagIn(List<Byte> values) {
            addCriterion("fill_flag in", values, "fillFlag");
            return (Criteria) this;
        }

        public Criteria andFillFlagNotIn(List<Byte> values) {
            addCriterion("fill_flag not in", values, "fillFlag");
            return (Criteria) this;
        }

        public Criteria andFillFlagBetween(Byte value1, Byte value2) {
            addCriterion("fill_flag between", value1, value2, "fillFlag");
            return (Criteria) this;
        }

        public Criteria andFillFlagNotBetween(Byte value1, Byte value2) {
            addCriterion("fill_flag not between", value1, value2, "fillFlag");
            return (Criteria) this;
        }

        public Criteria andTodoIdIsNull() {
            addCriterion("todo_id is null");
            return (Criteria) this;
        }

        public Criteria andTodoIdIsNotNull() {
            addCriterion("todo_id is not null");
            return (Criteria) this;
        }

        public Criteria andTodoIdEqualTo(String value) {
            addCriterion("todo_id =", value, "todoId");
            return (Criteria) this;
        }

        public Criteria andTodoIdNotEqualTo(String value) {
            addCriterion("todo_id <>", value, "todoId");
            return (Criteria) this;
        }

        public Criteria andTodoIdGreaterThan(String value) {
            addCriterion("todo_id >", value, "todoId");
            return (Criteria) this;
        }

        public Criteria andTodoIdGreaterThanOrEqualTo(String value) {
            addCriterion("todo_id >=", value, "todoId");
            return (Criteria) this;
        }

        public Criteria andTodoIdLessThan(String value) {
            addCriterion("todo_id <", value, "todoId");
            return (Criteria) this;
        }

        public Criteria andTodoIdLessThanOrEqualTo(String value) {
            addCriterion("todo_id <=", value, "todoId");
            return (Criteria) this;
        }

        public Criteria andTodoIdLike(String value) {
            addCriterion("todo_id like", value, "todoId");
            return (Criteria) this;
        }

        public Criteria andTodoIdNotLike(String value) {
            addCriterion("todo_id not like", value, "todoId");
            return (Criteria) this;
        }

        public Criteria andTodoIdIn(List<String> values) {
            addCriterion("todo_id in", values, "todoId");
            return (Criteria) this;
        }

        public Criteria andTodoIdNotIn(List<String> values) {
            addCriterion("todo_id not in", values, "todoId");
            return (Criteria) this;
        }

        public Criteria andTodoIdBetween(String value1, String value2) {
            addCriterion("todo_id between", value1, value2, "todoId");
            return (Criteria) this;
        }

        public Criteria andTodoIdNotBetween(String value1, String value2) {
            addCriterion("todo_id not between", value1, value2, "todoId");
            return (Criteria) this;
        }
    }

    public static class Criteria extends GeneratedCriteria implements Serializable {

        protected Criteria() {
            super();
        }
    }

    public static class Criterion implements Serializable {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}